#!/usr/bin/env python
#
# Programmer   : Rikih Gunawan
# Email        : dr_slump@gawab.com
#
# Gunadarma University @2001
# Copyleft(c) 2004 dr_slump technology
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

from socket import *
import commands
import os
import sys
import time
import string

lstCmd    = ['dir','ls','exit','bye','quit','get','mget',
	     'put','mput','rm','delete','mv','rename','cd','pwd','chmod','cp','copy',
	     'rmdir','mkdir','close','disconnect']
hostIP    = '127.0.0.1'
hostPort  = 1111
filFlag   = '*file*'
getFlag   = 'get'

class CMD:
    def __init__(self):
	self.byeFlag = '*bye*'
    
    def checkCmd(self, cmd):
	ret = ''	
	cmd = cmd.strip().split()
	cmd[0] = cmd[0].lower()
	
	if cmd[0] in lstCmd:
	    if cmd[0] in ['ls','dir']:
		if len(cmd) == 1:
		    cmdS = 'ls -al'
		else:
		    cmdS = 'ls' + ' ' +  cmd[1]	
		ret = commands.getoutput(cmdS)	    	
	    
	    elif cmd[0] in ['rm','delete']:
		if len(cmd) == 2:		    			
		    ret  = commands.getoutput('rm ' + cmd[1])
		    if ret == '':
			ret = 'File ' + cmd[1] + ' telah di hapus.'
		else:
		    ret  = 'penggunaan: rm|delete [file].'

	    elif cmd[0] in ['rmdir']:
		if len(cmd) == 2:		    			
		    ret = commands.getoutput('rm -rf ' + cmd[1])
		    if ret == '':
			ret = 'Direktori ' + cmd[1] + ' telah di hapus.'
		else:
		    ret  = 'rmdir [direktori].'

	    elif cmd[0] in ['mkdir']:
		if len(cmd) == 2:		    			
		    ret = commands.getoutput('mkdir ' + cmd[1])
		    if ret == '':
			ret = 'Direktori ' + cmd[1] + ' telah di buat.'
		else:
		    ret  = 'penggunaan: mkdir [direktori].'
	    
	    elif cmd[0] in ['mv','rename']:
		if len(cmd) == 3:		    			
		    ret  = commands.getoutput('mv ' + cmd[1] + ' ' + cmd[2])
		else:
		    ret  = 'penggunaan: mv|rename [file_lama] [file_baru].'

	    elif cmd[0] in ['cp','copy']:
		if len(cmd) == 3:		    			
		    ret  = commands.getoutput('cp ' + cmd[1] + ' ' + cmd[2])
		else:
		    ret  = 'penggunaan: cp|copy [file_sumber] [tujuan].'

	    elif cmd[0] in ['chmod']:
		if len(cmd) == 3:		    			
		    ret  = commands.getoutput('chmod ' + cmd[1] + ' ' + cmd[2])
		    if ret == '':
			ret = 'Hak akses ' + cmd[1] + ' telah di ubah.'
		else:
		    ret  = 'penggunaan: chmod [mode] [file].'

	    elif cmd[0] in ['cd']:
		if len(cmd) == 2:
		    try:
			os.chdir(cmd[1])
		    except:
			ret = 'Direktori tidak ada.'
		    else:
			ret = 'Direktori sekarang ' + os.getcwd()
		else:
		    ret  = 'penggunaan: cd [direktori]'		

	    elif cmd[0] in ['pwd']:
		ret = 'Direktori sekarang ' + commands.getoutput('pwd')
		
	    elif cmd[0] in ['bye','exit','quit','close','disconnect']:
		ret = self.byeFlag
			    	
	return ret
	    	    
class CLI:    
    def __init__(self):    	
	self.cmd      = CMD()
	self.childLst = []

    def updatePid(self, pids):
	while self.childLst:
	    pid, status = os.waitpid(0, os.WNOHANG)
	    if not pid : break
	    pids.remove(pid)

    def sendFile(self,sock,file):
	sock.send(filFlag)
	user = os.environ['USER']
    	command = filFlag	
	size = os.stat(file)[6]
	try:
	    f = open(file,'r')
	except:
	    ret = 0
	else:
	    pos = 0
	    while 1:
		if pos == 0:	
	    	    buffer = f.read(5000000-282)
		    if not buffer: break
		    count = sock.send(command + ':' + \
		    string.rjust(os.path.basename(file),214) + ':' + \
	    	    string.rjust(str(size).strip(),30) + ':' + \
	    	    string.rjust(str(user).strip(),30) + \
		    buffer)
		    pos = 1
		else:
		    buffer = f.read(5000000)
		    if not buffer: break
		    count = sock.send(buffer)
	    ret = 1	
	return ret

    def recvFile(self,sock):
	pjg 	 = 0
	msg1 	 = sock.recv(283).split(':')
	flag     = msg1[0].strip()
	namafile = msg1[1].strip()
	total	 = msg1[2].strip()
	user     = msg1[3].strip()	
	file 	 = namafile
	if flag == filFlag:
	    try:
		f = open(file,'w')
	    except:	    				
		ret = 0
	    else:
		try:
		    while 1:			
    			leftToRead = int(total) - pjg	    
    			if not leftToRead: break		
    			msg = sock.recv(5000000)
			pjg = pjg + len(msg)
			f.write(msg)
		    f.close()	
		except:			    
		    os.remove(file)		    
		    ret = 0
		else:
		    ret = 1
		ret = 1	    
	    return ret

    def handler(self, sock):
	sock.send('\n\rSelamat datang di DrSlump FTP Server\n\r')
	while 1:
	    data = sock.recv(1024)
	    if not data: break	
	    if data[:len(filFlag)] == filFlag:
		ret = self.recvFile(sock)
		if ret == 1:
		    ret = 'File telah di terima'
		else:
		    ret = 'File gagal di terima'
		sock.send(ret)
	    elif data[:len(getFlag)] == getFlag:
		cmd = data.strip().split()
		cmd[0] = cmd[0].lower()
		self.sendFile(sock, cmd[1])	
	    else:
		ret = self.cmd.checkCmd(data)
		if ret == self.cmd.byeFlag:		
		    sock.send('Koneksi di tutup...\n\r')
		    sock.close()
		    break
		sock.send(str(ret) + '\n\r')	    	
    
    def runCmd(self):	
	print '\n\r + + + Dr_slump FTP Server + + +\n'
	try:		
	    print 'Membuat socket...'
	    sockCmd = socket(AF_INET, SOCK_STREAM)
	except:
	    print 'Gagal buat socket !'
	    sys.exit()
	else:
	    sockCmd.setsockopt(SOL_SOCKET, SO_REUSEADDR, 1)	    
	    try:	    
	        print 'Mengikatkan socket ke ' + hostIP + ' port ' + str(hostPort)
		sockCmd.bind((hostIP, hostPort))
	    except:
		print 'Gagal mengikatkan socket !'
		sys.exit()
	    else:
		print 'Mendengarkan koneksi...\n\r'		
		sockCmd.listen(5)		
		while 1:	    	    
		    koneksi, alamat = sockCmd.accept()
		    self.updatePid(self.childLst)
		    pid = os.fork()    
		    if pid: #parent
		        koneksi.close()		    
		        self.childLst.append(pid)

		    if not pid: #child
		        sockCmd.close()
		        self.handler(koneksi)
		        os._exit(0)
	
   		    		    		
if __name__ == "__main__":
    cli = CLI()
    cli.runCmd()    
	
